Imports System.IO

Public Class frmMain
#Region "Trivial"
    Private Sub cmdExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdExit.Click
        Me.Close()
    End Sub

    Private Sub cmdCurrent1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCurrent1.Click
        dateCreated.Value = DateTime.Now : timeCreated.Text = DateTime.Now
    End Sub

    Private Sub cmdCurrent2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCurrent2.Click
        dateAccessed.Value = DateTime.Now : timeAccessed.Text = DateTime.Now
    End Sub

    Private Sub cmdCurrent3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCurrent3.Click
        dateWritten.Value = DateTime.Now : timeWritten.Text = DateTime.Now
    End Sub
#End Region

    ' The file we're currently accessing
    Public CurrentFile As FileSystemInfo

    Public Sub UpdateControls()

        ' Enable/disable controls
        For Each Control As Control In panelControls.Controls
            Control.Enabled = (CurrentFile IsNot Nothing)
        Next

        ' Load the data in question
        If CurrentFile IsNot Nothing Then
            SetValues(CurrentFile.CreationTime, dateCreated, timeCreated)
            SetValues(CurrentFile.LastAccessTime, dateAccessed, timeAccessed)
            SetValues(CurrentFile.LastWriteTime, dateWritten, timeWritten)
        End If

    End Sub

    Public Sub SetValues(ByVal Value As Date, ByVal DatePicker As DateTimePicker, ByVal TimePicker As MaskedTextBox)

        ' Set both controls
        DatePicker.Value = Value.Date : TimePicker.Text = Value.TimeOfDay.ToString

    End Sub

    Private Sub txtFilePath_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles txtFilePath.DragDrop

        ' Store the new data
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            txtFilePath.Text = e.Data.GetData(DataFormats.FileDrop)(0)
        End If

    End Sub

    Private Sub txtFilePath_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles txtFilePath.DragEnter

        ' Signal that this is allowed
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            e.Effect = DragDropEffects.Copy
        End If

    End Sub

    Private Sub txtFilePath_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtFilePath.TextChanged

        ' Make sure the given path is valid
        If File.Exists(txtFilePath.Text) Then

            ' If so, load it.
            CurrentFile = New FileInfo(txtFilePath.Text)

        ElseIf Directory.Exists(txtFilePath.Text) Then

            ' Load the directory info
            CurrentFile = New DirectoryInfo(txtFilePath.Text)

        End If

        ' Update controls
        UpdateControls()

    End Sub

    Private Sub cmdChange_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdChange.Click

        Try
            ' Let the file contain these new values
            CurrentFile.CreationTime = dateCreated.Value + Date.Parse(timeCreated.Text).TimeOfDay
            CurrentFile.LastAccessTime = dateAccessed.Value + Date.Parse(timeAccessed.Text).TimeOfDay
            CurrentFile.LastWriteTime = dateWritten.Value + Date.Parse(timeWritten.Text).TimeOfDay
        Catch ex As Exception
            ' Inform about the error
            MessageBox.Show(ex.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    Private Sub cmdBrowse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdBrowse.Click

        ' Store the result if success
        If dialogFindFile.ShowDialog = Windows.Forms.DialogResult.OK Then
            txtFilePath.Text = dialogFindFile.FileName
        End If

    End Sub

    Private Sub cmdAbout_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdAbout.Click

        ' Show the about-form
        frmAbout.ShowDialog()

    End Sub

End Class
